/*******************************************************************************
*    SMS Professional 1.2 for PalmOS                                           *
*    Copyright (C) 2006-2007 Luca Bertoncello                                  *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

#include <PalmOS.h>
#include "addBookLib.h"

void translateData(addrBookRaw *raw, addrBookData *data)
{
  int l, field, pos, nFields;
  UInt32 fields, f1, f2, f3, f4;
  UInt8 fieldPos[19];

  f1 = (UInt32) raw->field1;
  f2 = (UInt32) raw->field2;
  f3 = (UInt32) raw->field3;
  f4 = (UInt32) raw->field4;
  fields = (f1 * 16777216) + (f2 * 65536) + (f3 * 256) + f4;

  data->lastName = NULL;
  data->firstName = NULL;
  data->firm = NULL;
  data->workPhone = NULL;
  data->homePhone = NULL;
  data->fax = NULL;
  data->other = NULL;
  data->eMail = NULL;
  data->address = NULL;
  data->town = NULL;
  data->region = NULL;
  data->zip = NULL;
  data->land = NULL;
  data->title = NULL;
  data->userDefined1 = NULL;
  data->userDefined2 = NULL;
  data->userDefined3 = NULL;
  data->userDefined4 = NULL;
  data->remarks = NULL;

  nFields = 0;
  if(fields & maskLastName)
  {
    fieldPos[nFields++] = fieldLastName;
    data->lastName = MemPtrNew(256);
    MemSet(data->lastName, 256, 0);
  }
  if(fields & maskFirstName)
  {
    fieldPos[nFields++] = fieldFirstName;
    data->firstName = MemPtrNew(256);
    MemSet(data->firstName, 256, 0);
  }
  if(fields & maskFirm)
  {
    fieldPos[nFields++] = fieldFirm;
    data->firm = MemPtrNew(256);
    MemSet(data->firm, 256, 0);
  }
  if(fields & maskWorkPhone)
  {
    fieldPos[nFields++] = fieldWorkPhone;
    data->workPhone = MemPtrNew(256);
    MemSet(data->workPhone, 256, 0);
  }
  if(fields & maskHomePhone)
  {
    fieldPos[nFields++] = fieldHomePhone;
    data->homePhone = MemPtrNew(256);
    MemSet(data->homePhone, 256, 0);
  }
  if(fields & maskFax)
  {
    fieldPos[nFields++] = fieldFax;
    data->fax = MemPtrNew(256);
    MemSet(data->fax, 256, 0);
  }
  if(fields & maskOther)
  {
    fieldPos[nFields++] = fieldOther;
    data->other = MemPtrNew(256);
    MemSet(data->other, 256, 0);
  }
  if(fields & maskEMail)
  {
    fieldPos[nFields++] = fieldEMail;
    data->eMail = MemPtrNew(256);
    MemSet(data->eMail, 256, 0);
  }
  if(fields & maskAddress)
  {
    fieldPos[nFields++] = fieldAddress;
    data->address = MemPtrNew(256);
    MemSet(data->address, 256, 0);
  }
  if(fields & maskTown)
  {
    fieldPos[nFields++] = fieldTown;
    data->town = MemPtrNew(256);
    MemSet(data->town, 256, 0);
  }
  if(fields & maskRegion)
  {
    fieldPos[nFields++] = fieldRegion;
    data->region = MemPtrNew(256);
    MemSet(data->region, 256, 0);
  }
  if(fields & maskZip)
  {
    fieldPos[nFields++] = fieldZip;
    data->zip = MemPtrNew(256);
    MemSet(data->zip, 256, 0);
  }
  if(fields & maskLand)
  {
    fieldPos[nFields++] = fieldLand;
    data->land = MemPtrNew(256);
    MemSet(data->land, 256, 0);
  }
  if(fields & maskTitle)
  {
    fieldPos[nFields++] = fieldTitle;
    data->title = MemPtrNew(256);
    MemSet(data->title, 256, 0);
  }
  if(fields & maskUserDefined1)
  {
    fieldPos[nFields++] = fieldUserDefined1;
    data->userDefined1 = MemPtrNew(256);
    MemSet(data->userDefined1, 256, 0);
  }
  if(fields & maskUserDefined2)
  {
    fieldPos[nFields++] = fieldUserDefined2;
    data->userDefined2 = MemPtrNew(256);
    MemSet(data->userDefined2, 256, 0);
  }
  if(fields & maskUserDefined3)
  {
    fieldPos[nFields++] = fieldUserDefined3;
    data->userDefined3 = MemPtrNew(256);
    MemSet(data->userDefined3, 256, 0);
  }
  if(fields & maskUserDefined4)
  {
    fieldPos[nFields++] = fieldUserDefined4;
    data->userDefined4 = MemPtrNew(256);
    MemSet(data->userDefined4, 256, 0);
  }
  if(fields & maskRemarks)
  {
    fieldPos[nFields++] = fieldRemarks;
    data->remarks = MemPtrNew(256);
    MemSet(data->remarks, 256, 0);
  }

  for(pos = field = l = 0; field < nFields; l++)
  {
    if(raw->Data[l] == 0)
    {
      field++;
      pos = 0;
      if(raw->Data[l + 1] == 0)
        field = nFields;
    }
    else
    {
      switch(fieldPos[field])
      {
        case fieldLastName:
          data->lastName[pos++] = raw->Data[l];
        break;
        case fieldFirstName:
          data->firstName[pos++] = raw->Data[l];
        break;
        case fieldFirm:
          data->firm[pos++] = raw->Data[l];
        break;
        case fieldWorkPhone:
          data->workPhone[pos++] = raw->Data[l];
        break;
        case fieldHomePhone:
          data->homePhone[pos++] = raw->Data[l];
        break;
        case fieldFax:
          data->fax[pos++] = raw->Data[l];
        break;
        case fieldOther:
          data->other[pos++] = raw->Data[l];
        break;
        case fieldEMail:
          data->eMail[pos++] = raw->Data[l];
        break;
        case fieldAddress:
          data->address[pos++] = raw->Data[l];
        break;
        case fieldTown:
          data->town[pos++] = raw->Data[l];
        break;
        case fieldRegion:
          data->region[pos++] = raw->Data[l];
        break;
        case fieldZip:
          data->zip[pos++] = raw->Data[l];
        break;
        case fieldLand:
          data->land[pos++] = raw->Data[l];
        break;
        case fieldTitle:
          data->title[pos++] = raw->Data[l];
        break;
        case fieldUserDefined1:
          data->userDefined1[pos++] = raw->Data[l];
        break;
        case fieldUserDefined2:
          data->userDefined2[pos++] = raw->Data[l];
        break;
        case fieldUserDefined3:
          data->userDefined3[pos++] = raw->Data[l];
        break;
        case fieldUserDefined4:
          data->userDefined4[pos++] = raw->Data[l];
        break;
        case fieldRemarks:
          data->remarks[pos++] = raw->Data[l];
        break;
        default:
          pos++;
        break;
      }
    }
  }
}

int areNumberEqual(Char *num, Char *cmp)
{
  Char *n1;
  int l, k, ret = 0;

  n1 = MemPtrNew(256);
  MemSet(n1, 256, 0);
  if(num[0] == '0')
    l = 1;
  else
    l = 0;
  for(k = 0; l < StrLen(num); l++)
    if(num[l] >= '0' && num[l] <= '9')
      n1[k++] = num[l];

  if(StrStr(n1, cmp) != NULL)
    ret = 1;

  MemPtrFree(n1);

  return ret;
}

int isNumberInRecord(Char *cmp, addrBookRaw *raw)
{
  int pos, l, ret = 0;
  Char *field;

  field = MemPtrNew(2560);
  MemSet(field, 2560, 0);
  for(pos = l = 0; l < 4864 && ret == 0; l++)
  {
    if(raw->Data[l] == 0)
    {
      if(areNumberEqual(field, cmp) != 0)
        ret = 1;
      pos = 0;
      MemSet(field, 2560, 0);
      if(raw->Data[l + 1] == 0)
        l = 5000;
    }
    else
      field[pos++] = raw->Data[l];
  }
  MemPtrFree(field);

  return ret;
}

int getNameFromNumber(Char *num, Char *name)
{
  DmOpenRef AddressDB;
  LocalID AddressDBID;
  UInt16 nRecords;
  MemHandle memH;
  UInt16 i;
  addrBookRaw *raw;
  addrBookData addr;
  Char cmp[256];
  int l, k, ret;

  if(num[0] == '0')
    l = 1;
  else
    l = 0;
  MemSet(cmp, 256, 0);
  for(k = 0; l < StrLen(num); l++)
    if(num[l] >= '0' && num[l] <= '9')
      cmp[k++] = num[l];

  MemSet(name, 256, 0);
  ret = 0;
  AddressDBID = DmFindDatabase(0, "AddressDB");
  AddressDB = DmOpenDatabase(0, AddressDBID, dmModeReadOnly);
  nRecords = DmNumRecords(AddressDB);
  for (i = 0; (i < nRecords) && (ret == 0); i++)
  {
    memH = DmQueryRecord(AddressDB, i);
    if(memH != NULL)
      raw = (addrBookRaw *) MemHandleLock(memH);
    else
      raw = NULL;
    if(raw != NULL)
    {
      if(isNumberInRecord(cmp, raw))
      {
        ret = 1;
        translateData(raw, &addr);
        i = nRecords;

        if(addr.lastName != NULL && addr.firstName != NULL)
          StrPrintF(name, "%s %s", addr.lastName, addr.firstName);
        else if(addr.lastName != NULL && addr.firstName == NULL)
          StrPrintF(name, "%s", addr.lastName);
        else if(addr.lastName == NULL && addr.firstName != NULL)
          StrPrintF(name, "%s", addr.firstName);
        else if(addr.lastName == NULL && addr.firstName == NULL && addr.firm != NULL)
          StrPrintF(name, "%s", addr.firm);
        else
          StrCopy(name, "");
        
        if(addr.lastName != NULL)
          MemPtrFree(addr.lastName);
        if(addr.firstName != NULL)
          MemPtrFree(addr.firstName);
        if(addr.firm != NULL)
          MemPtrFree(addr.firm);
        if(addr.workPhone != NULL)
          MemPtrFree(addr.workPhone);
        if(addr.homePhone != NULL)
          MemPtrFree(addr.homePhone);
        if(addr.fax != NULL)
          MemPtrFree(addr.fax);
        if(addr.other != NULL)
          MemPtrFree(addr.other);
        if(addr.eMail != NULL)
          MemPtrFree(addr.eMail);
        if(addr.address != NULL)
          MemPtrFree(addr.address);
        if(addr.town != NULL)
          MemPtrFree(addr.town);
        if(addr.region != NULL)
          MemPtrFree(addr.region);
        if(addr.zip != NULL)
          MemPtrFree(addr.zip);
        if(addr.land != NULL)
          MemPtrFree(addr.land);
        if(addr.title != NULL)
          MemPtrFree(addr.title);
        if(addr.userDefined1 != NULL)
          MemPtrFree(addr.userDefined1);
        if(addr.userDefined2 != NULL)
          MemPtrFree(addr.userDefined2);
        if(addr.userDefined3 != NULL)
          MemPtrFree(addr.userDefined3);
        if(addr.userDefined4 != NULL)
          MemPtrFree(addr.userDefined4);
        if(addr.remarks != NULL)
          MemPtrFree(addr.remarks);
      }
    }
    if(memH != NULL)
      MemHandleUnlock(memH);
  }
  DmCloseDatabase(AddressDB);

  return(ret);
}
