/*******************************************************************************
*    SMS Professional 1.2 for PalmOS                                           *
*    Copyright (C) 2006-2007 Luca Bertoncello                                  *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

#define maskLastName      0x100
#define maskFirstName     0x200
#define maskFirm          0x400
#define maskWorkPhone     0x800
#define maskHomePhone     0x1000
#define maskFax           0x2000
#define maskOther         0x4000
#define maskEMail         0x8000
#define maskAddress       0x10000
#define maskTown          0x20000
#define maskRegion        0x40000
#define maskZip           0x80000
#define maskLand          0x100000
#define maskTitle         0x200000
#define maskUserDefined1  0x400000
#define maskUserDefined2  0x800000
#define maskUserDefined3  0x1000000
#define maskUserDefined4  0x2000000
#define maskRemarks       0x4000000

#define fieldLastName      0
#define fieldFirstName     1
#define fieldFirm          2
#define fieldWorkPhone     3
#define fieldHomePhone     4
#define fieldFax           5
#define fieldOther         6
#define fieldEMail         7
#define fieldAddress       8
#define fieldTown          9
#define fieldRegion        10
#define fieldZip           11
#define fieldLand          12
#define fieldTitle         13
#define fieldUserDefined1  14
#define fieldUserDefined2  15
#define fieldUserDefined3  16
#define fieldUserDefined4  17
#define fieldRemarks       18

typedef struct
{
  UInt8 na1;
  UInt16 na2;
  UInt8 na3;
  UInt8 field1;
  UInt8 field2;
  UInt8 field3;
  UInt8 field4;
  Char Data[4864];
} addrBookRaw;

typedef struct
{
  Char *lastName;
  Char *firstName;
  Char *firm;
  Char *workPhone;
  Char *homePhone;
  Char *fax;
  Char *other;
  Char *eMail;
  Char *address;
  Char *town;
  Char *region;
  Char *zip;
  Char *land;
  Char *title;
  Char *userDefined1;
  Char *userDefined2;
  Char *userDefined3;
  Char *userDefined4;
  Char *remarks;
} addrBookData;

void translateData(addrBookRaw *raw, addrBookData *data);
int areNumberEqual(Char *num, Char *cmp);
int getNameFromNumber(Char *num, Char *name);
int isNumberInRecord(Char *cmp, addrBookRaw *raw);
