/*******************************************************************************
*    SMS Professional 1.2 for PalmOS                                           *
*    Copyright (C) 2006-2007 Luca Bertoncello                                  *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

typedef struct DBRecordType
{
  Int16 mailbox;      // 0 = Inbox, 1 = Outbox, 2 = Sent
  char  phone[30];
  char  name[100];
  DateTimeType dateTime;
  char  text[1024];
  TelSmsDateTimeType arriving;
  UInt32 flags;       // for the future... :)
} DBRecordType;
typedef DBRecordType*   DBRecordTypePtr;
typedef struct
{
  Boolean delAfterReceive;
  Boolean sendConf;
} Preferences;

#define DBName                                  "SmsProDB"
#define DBType                                  'DATA'
#define NONE                                    -1
#define INBOX                                   0
#define OUTBOX                                  1
#define SENT                                    2

#define STAGEINIT				0
#define STAGESENDSMS				1
#define STAGESELSTORAGE				2
#define STAGEGETSMSCOUNT			3
#define STAGEGETDATASIZE			4
#define STAGERECEIVESMS				5
#define STAGEFINISH				6

#define SENDCONFIRMATIONFLAG                    1

void initSMSSystem();
void finishSMSSystem();
void sendReceiveSMS();
void sendSMS(DBRecordType dbRecord);
Boolean ProgressCallback(PrgCallbackDataPtr data);
